//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
#include "Unit6.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
int colors[9]={0,0x00ff00ff,0x0000ffff,0x00ffffff,0x00ff9f9f,0x00ff0000,0x0000ff00,0x000000ff,0x00303030};
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrawingCell(TObject *Sender, int ACol, int ARow,
      TRect &Rect, TGridDrawState State)
{
 if(cfg.conf.preview&&ACol>0&&ACol<5&&ARow>0&&ARow<5&&gls.nextblk.mtx[ACol-1][ARow-1])
 {
  DrawGrid2->Canvas->Brush->Color=colors[gls.nextblk.mtx[ACol-1][ARow-1]];
 }
 else
 {
  DrawGrid2->Canvas->Brush->Color=0;
 }
 DrawGrid2->Canvas->FillRect(Rect);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawingGlass(TObject *Sender, int ACol, int ARow,
      TRect &Rect, TGridDrawState State)
{
 if(cfg.conf.grid&&gls(ACol,ARow)==0)
 {
  if((ACol&1)^(ARow&1))
   DrawGrid1->Canvas->Brush->Color=colors[8];
  else
   DrawGrid1->Canvas->Brush->Color=colors[0];
 }
 else
  DrawGrid1->Canvas->Brush->Color=colors[gls(ACol,ARow)];
 DrawGrid1->Canvas->FillRect(Rect);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Tick(TObject *Sender)
{
 gls.movedown();
 QuickDraw();
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::KeyPressing(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 switch(Key)
 {
  case 0x25:
   gls.moveleft();
   QuickDraw();
  break;
  case 0x27:
   gls.moveright();
   QuickDraw();
  break;
  case 0x28:case 0x20:
   gls.drop();
  break;
  case 0x26:
   gls.rotate(cfg.conf.rotation);
   QuickDraw();
  break;
  case 0x50:
   gls.pause();
  break;
  case 0x1b:
   Close();
  break;
  case 0x41:
   About1Click(Sender);
  break;
  case 0x4e:
   New1Click(Sender);
  break;
  case 0x53:
   Setup1Click(Sender);
  break;
  case 0x54:
   Top101Click(Sender);
  break;
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Setup1Click(TObject *Sender)
{
 gls.pause(1);
 Application->CreateForm(__classid(TForm3),&Form3);
 if(Form3->ShowModal()==mrOk)
 {
  cfg.conf.startlevel=Form3->RadioGroup1->ItemIndex;
  cfg.conf.preview=Form3->CheckBox1->Checked;
  cfg.conf.grid=Form3->CheckBox2->Checked;
  cfg.conf.gridlight=Form3->TrackBar1->Position;
  colors[8]=(cfg.conf.gridlight<<17)|(cfg.conf.gridlight<<9)|(cfg.conf.gridlight<<1);
  cfg.conf.rotation=Form3->RadioGroup2->ItemIndex;
  DrawGrid1->Refresh();
 }
 Form3->Free();
 gls.pause(2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Pause1Click(TObject *Sender)
{
 gls.pause(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::New1Click(TObject *Sender)
{
 gls.newgame();
 DrawGrid2->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ShowMainForm(TObject *Sender)
{
 colors[8]=(cfg.conf.gridlight<<17)|(cfg.conf.gridlight<<9)|(cfg.conf.gridlight<<1);
 gls.newgame();
}

void TForm1::RefreshScore()
{
 char tmp[20];
 itoa(gls.score,tmp,10);
 StaticText1->Caption=tmp;
}

void TForm1::RefreshLines()
{
 char tmp[20];
 itoa(gls.lines,tmp,10);
 StaticText2->Caption=tmp;
}

void TForm1::RefreshLevel()
{
 char tmp[20];
 itoa(gls.level+1,tmp,10);
 StaticText3->Caption=tmp;
}

void TForm1::RefreshName()
{
 StaticText4->Caption=cfg.conf.top[0].name;
}

void TForm1::RefreshTopScore()
{
 char tmp[20];
 itoa(cfg.conf.top[0].score,tmp,10);
 StaticText5->Caption=tmp;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Top101Click(TObject *Sender)
{
 gls.pause(1);
 Application->CreateForm(__classid(TForm4),&Form4);
 Form4->ShowModal();
 Form4->Free();
 gls.pause(2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About1Click(TObject *Sender)
{
 gls.pause(1);
 Application->CreateForm(__classid(TForm6),&Form6);
 Form6->ShowModal();
 Form6->Free();
 gls.pause(2);
}

void TForm1::QuickDraw()
{
 TGridDrawState G;
 int i,j;
 for(i=gls.Xblk-1;i<gls.Xblk+5;i++)
  for(j=gls.Yblk-1;j<gls.Yblk+5;j++)
  {
   if(gls.inglass(i,j))
    DrawingGlass(this,i,j,DrawGrid1->CellRect(i,j),G);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCanResize(TObject *Sender, int &NewWidth,
      int &NewHeight, bool &Resize)
{
 //if(Tag==0)
 {
  Resize=true;
  int x,y;
  //y=(ClientHeight-5)/20;
  //x=(ClientWidth-158-5)/20;
  y=(NewHeight-(Height-ClientHeight)-5)/20;
  x=(NewWidth-(Width-ClientWidth)-5-158)/20;
  if(x<7)x=7;
  if(y<14)y=14;
  //if(x<7||y<14){Resize=false;return;}
  gls.resize(x,y);
  DrawGrid1->ColCount=x;
  DrawGrid1->RowCount=y;
  //ClientHeight=y*20+5;
  //ClientWidth=x*20+5+158;
  NewHeight=(Height-ClientHeight)+y*20+5;
  NewWidth=(Width-ClientWidth)+x*20+5+158;
  //DrawGrid1->Refresh();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
 DrawGrid1->Refresh();
 DrawGrid2->Refresh();
}
//---------------------------------------------------------------------------

