//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit4.h"
#include "Unit5.h"
#pragma package(smart_init)

glass gls;
config cfg;

int times[10]={1000,900,800,700,600,500,400,300,200,100};

void block::create(int type)
{
 int i,j;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   mtx[i][j]=0;
 switch(type)
 {
  case 1:
   mtx[1][0]=mtx[1][1]=mtx[1][2]=mtx[1][3]=1;
  break;
  case 2:
   mtx[1][0]=mtx[1][1]=mtx[1][2]=mtx[2][2]=2;
  break;
  case 3:
   mtx[2][0]=mtx[2][1]=mtx[2][2]=mtx[1][2]=3;
  break;
  case 4:
   mtx[1][0]=mtx[1][1]=mtx[1][2]=mtx[2][1]=4;
  break;
  case 5:
   mtx[2][0]=mtx[1][1]=mtx[2][1]=mtx[1][2]=5;
  break;
  case 6:
   mtx[1][0]=mtx[1][1]=mtx[2][1]=mtx[2][2]=6;
  break;
  case 7:
   mtx[1][1]=mtx[2][1]=mtx[1][2]=mtx[2][2]=7;
  break;
 }
}

block& block::operator=(block& A)
{
 int i,j;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   mtx[i][j]=A.mtx[i][j];
 return *this;
}

void block::rotate(int dir)
{
 char mtx2[4][4];
 int i,j;
 int max=4;
 if(mtx[1][1]==4)max=3;
 if(dir)
 {
  for(i=0;i<max;i++)
   for(j=0;j<max;j++)
    mtx2[j][max-1-i]=mtx[i][j];
 }
 else
 {
  for(i=0;i<max;i++)
   for(j=0;j<max;j++)
    mtx2[max-1-j][i]=mtx[i][j];
 }
 for(i=0;i<max;i++)
   for(j=0;j<max;j++)
    mtx[i][j]=mtx2[i][j];
}

glass::glass()
{
 randomize();
 Xsize=12;
 Ysize=19;
 stat=0;
 fld=new char[12*19];
}

glass::~glass()
{
 if(fld)delete [] fld;
}

void glass::newgame()
{
 int i,j;
 for(i=0;i<Xsize;i++)
  for(j=0;j<Ysize;j++)
   fld[i+j*Xsize]=0;
 nextblk.create(random(7)+1);
 stat=1;
 add();
 score=0;
 Form1->RefreshScore();
 lines=0;
 Form1->RefreshLines();
 level=cfg.conf.startlevel;
 Form1->Timer1->Interval=times[level];
 Form1->RefreshLevel();
 Form1->RefreshName();
 Form1->RefreshTopScore();
 Form1->DrawGrid1->Refresh();
}

void glass::add()
{
 if(stat!=4)
 {
  blk=nextblk;
  nextblk.create(random(7)+1);
  int i,j;
  Xblk=Xsize/2-2;
  Yblk=0;
  stat=1;
  for(i=0;i<4;i++)
   for(j=0;j<4;j++)
    if(blk.mtx[i][j]&&fld[i+Xblk+j*Xsize])
     stat=4;
  if(stat==4)endgame();
  else if(stat==1)
  {
   for(i=0;i<4;i++)
    for(j=0;j<4;j++)
     if(blk.mtx[i][j])fld[i+Xblk+j*Xsize]=blk.mtx[i][j];
   //Form1->DrawGrid1->Refresh();
   Form1->QuickDraw();
   score+=5;
   Form1->RefreshScore();
  }
 }
}

void glass::endgame()
{
 int i;
 int ins=-1;
 for(i=0;i<10;i++)
  if(score>cfg.conf.top[i].score)
  {
   ins=i;
   break;
  }
 if(ins>-1)
 {
  Application->CreateForm(__classid(TForm5),&Form5);
  Application->CreateForm(__classid(TForm4),&Form4);
  Form5->ShowModal();
  for(i=9;i>ins;i--)
  {
   cfg.conf.top[i].score=cfg.conf.top[i-1].score;
   strcpy(cfg.conf.top[i].name,cfg.conf.top[i-1].name);
  }
  cfg.conf.top[ins].score=score;
  strcpy(cfg.conf.top[ins].name,Form5->Edit1->Text.c_str());
  Form4->selection=ins;
  Form4->ShowModal();
  Form4->Free();
  Form5->Free();
  newgame();
 }
}

void glass::resize(int x,int y)
{
 int i,j;
 if(stat!=4)
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(blk.mtx[i][j]&&inglass(i+Xblk,j+Yblk))fld[i+Xblk+(j+Yblk)*Xsize]=0;
 char* newfld;
 newfld=new char[x*y];
 for(i=0;i<x;i++)
  for(j=0;j<y;j++)
   newfld[i+j*x]=0;
 for(i=0;i<Xsize&&i<x;i++)
  for(j=0;j<Ysize&&j<y;j++)
   newfld[i+(y-1-j)*x]=fld[i+(Ysize-1-j)*Xsize];
 delete [] fld;
 fld=newfld;
 Xsize=x;
 Ysize=y;
 if(stat!=4)stat=3;
 add();
 Form1->DrawGrid1->Refresh();
}

void glass::movedown()
{
 if(stat==2)
 {
  stat=3;
  analize();
  add();
  Form1->DrawGrid2->Refresh();
 }
 else if(stat==1&&Application->Active)
 {
 int stopdown=0;
 int i,j;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(blk.mtx[i][j])fld[i+Xblk+(j+Yblk)*Xsize]=0;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(blk.mtx[i][j]&&(!inglass(i+Xblk,j+Yblk+1)||fld[i+Xblk+(j+Yblk+1)*Xsize]))
   {
    stopdown=1;
    stat=2;
   }
 if(!stopdown) Yblk++;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(inglass(i+Xblk,j+Yblk)&&blk.mtx[i][j])fld[i+Xblk+(j+Yblk)*Xsize]=blk.mtx[i][j];
 }
}

void glass::moveleft()
{
 if(stat==1||stat==2)
 {
 int stop=0;
 int i,j;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(blk.mtx[i][j])fld[i+Xblk+(j+Yblk)*Xsize]=0;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(blk.mtx[i][j]&&(!inglass(i+Xblk-1,j+Yblk)||fld[i+Xblk-1+(j+Yblk)*Xsize]))
   {
    stop=1;
   }
 if(!stop)
 {
  Xblk--;
  stat=1;
 }
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(inglass(i+Xblk,j+Yblk)&&blk.mtx[i][j])fld[i+Xblk+(j+Yblk)*Xsize]=blk.mtx[i][j];
 }
}

void glass::moveright()
{
 if(stat==1||stat==2)
 {
 int stop=0;
 int i,j;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(blk.mtx[i][j])fld[i+Xblk+(j+Yblk)*Xsize]=0;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(blk.mtx[i][j]&&(!inglass(i+Xblk+1,j+Yblk)||fld[i+Xblk+1+(j+Yblk)*Xsize]))
   {
    stop=1;
   }
 if(!stop)
 {
  Xblk++;
  stat=1;
 }
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(inglass(i+Xblk,j+Yblk)&&blk.mtx[i][j])fld[i+Xblk+(j+Yblk)*Xsize]=blk.mtx[i][j];
 }
}

void glass::drop()
{
 while(stat==1)
 {
  movedown();
  //Form1->DrawGrid1->Refresh();
  Form1->QuickDraw();
  score++;
  Form1->RefreshScore();
 }
}

void glass::rotate(int dir)
{
 if(!(stat==1||stat==2))return;
 block T;
 T=blk;
 T.rotate(dir);
 int i,j;
 int stop=0;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(blk.mtx[i][j])fld[i+Xblk+(j+Yblk)*Xsize]=0;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(T.mtx[i][j]&&(!inglass(i+Xblk,j+Yblk)||fld[i+Xblk+(j+Yblk)*Xsize]))
    stop=i+1;
 if(stop==1||stop==2)
 {
  int Xpls=0;
  stop=0;
  for(i=0;i<4;i++)
   for(j=0;j<4;j++)
    if(T.mtx[i][j]&&(!inglass(i+Xblk+2,j+Yblk)||fld[i+Xblk+2+(j+Yblk)*Xsize]))
     stop=1;
  if(!stop)Xpls=2;
  stop=0;
  for(i=0;i<4;i++)
   for(j=0;j<4;j++)
    if(T.mtx[i][j]&&(!inglass(i+Xblk+1,j+Yblk)||fld[i+Xblk+1+(j+Yblk)*Xsize]))
     stop=1;
  if(!stop)Xpls=1;
  if(Xpls)stop=0;
  Xblk+=Xpls;
 }
 else if(stop==3||stop==4)
 {
  int Xmin=0;
  stop=0;
  for(i=0;i<4;i++)
   for(j=0;j<4;j++)
    if(T.mtx[i][j]&&(!inglass(i+Xblk-2,j+Yblk)||fld[i+Xblk-2+(j+Yblk)*Xsize]))
     stop=1;
  if(!stop)Xmin=2;
  stop=0;
  for(i=0;i<4;i++)
   for(j=0;j<4;j++)
    if(T.mtx[i][j]&&(!inglass(i+Xblk-1,j+Yblk)||fld[i+Xblk-1+(j+Yblk)*Xsize]))
     stop=1;
  if(!stop)Xmin=1;
  if(Xmin)stop=0;
  Xblk-=Xmin;
 }
 if(!stop)
 {
  blk=T;
  stat=1;
 }
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   if(inglass(i+Xblk,j+Yblk)&&blk.mtx[i][j])fld[i+Xblk+(j+Yblk)*Xsize]=blk.mtx[i][j];
}

void glass::analize()
{
 int forline[5]={0,10,90,900,9000};
 int n=0;
 int i,j;
 int solid;
 for(j=0;j<Ysize;j++)
 {
  solid=1;
  for(i=0;i<Xsize;i++)
   if(fld[i+j*Xsize]==0)
   {
    solid=0;
    break;
   }
  if(solid)
  {
   delline(j);
   Form1->DrawGrid1->Refresh();
   n++;
   score+=forline[n];
   Form1->RefreshScore();
   lines++;
   Form1->RefreshLines();
   if(!(lines%20))
   {
    level++;
    if(level>9)level=9;
    Form1->Timer1->Interval=times[level];
    Form1->RefreshLevel();
   }
  }
 }
}

void glass::delline(int n)
{
 int i,j;
 for(j=n-1;j>=0;j--)
  for(i=0;i<Xsize;i++)
   fld[i+(j+1)*Xsize]=fld[i+j*Xsize];
 for(i=0;i<Xsize;i++)
   fld[i]=0;
}

void glass::pause(int mode)
{
 static int paused=0;
 static int prestat=1;
 switch(mode)
 {
  case 0:
   if(paused)
   {
    paused=0;
    stat=prestat;
   }
   else
   {
   paused=1;
   prestat=stat;
   stat=0;
   }
  break;
  case 1:
   if(!paused)prestat=stat;
   stat=0;
  break;
  case 2:
   if(!paused)stat=prestat;
  break;
 }
}

config::config()
{
 strcpy(filename,"Tetris.cfg");
 FILE* F;
 F=fopen(filename,"rb");
 if(F)
 {
  fread(&conf,sizeof(forsave),1,F);
  fclose(F);
 }
 else
 {
  int i;
  for(i=0;i<10;i++)
  {
   conf.top[i].name[0]=0;
   conf.top[i].score=0;
  }
  conf.startlevel=0;
  conf.preview=1;
  conf.grid=0;
  conf.gridlight=12;
  conf.rotation=0;
 }
}

config::~config()
{
 FILE *F;
 F=fopen(filename,"wb");
 if(F)
 {
  fwrite(&conf,sizeof(forsave),1,F);
  fclose(F);
 }
}
//---------------------------------------------------------------------------

